# cornell.py
# adapted from Fall 2019 Prelim 2 Question 4


# We are making Cornell!
# For the purposes of this example, students can only have ONE major and once
# they declare it, they cannot change it (what a scary idea...)

class Cornellian():
    """
    A class representing a person at Cornell.

    CLASS ATTRIBUTES:
        NEXT_NUM [int > 0]: a unique number that is assigned to one student
            or professor; it is incremented by 1 every time a Cornellian
            object is created

    INSTANCE ATTRIBUTES:
        first_name [nonempty string]: first name of this Cornellian
        last_name [nonempty string]: last name of this Cornellian
        cuid [string]: unique ID of this Cornellian
    """

    # STUDENTS--Put any class attributes here


    def __init__():
        """ Initializes a Cornellian with first_name 'first' and last_name 'last'.

        The cuid of this Cornellian is a string with 3 character: the lower-cased first
        letter of the Cornellian's first name and the lower-cased first letter of their
        last name and the value of NEXT_NUM.
        It also increments the class attribute NEXT_NUM by one.

        Precondition:
            first is a nonempty string
            last is a nonempty string
        """

        # STUDENTS--You need to do the following:
            # 1. Put the parameters into the __init__ method header above
            # 2. Complete this method so it follows the specification above
        pass

    def __eq__():
        """
        Returns True if other is a Cornellian object equal to this one.

        Two Cornellians are equal if they:
            1. Both have the same cuid
        NOTICE: Two Cornellians can be equal if they have different names

        Preconditions: None (other can be anything)
        """

        # STUDENTS--You need to do the following:
            # 1. Put the parameters into the __eq__ method header above
            # 2. Complete this method so it follows the specification above
        pass

class Professor(Cornellian):
    """
    A class representing a Professor at Cornell.

    CLASS ATTRIBUTES:
        departments: a list of departments that have Professors
        all_of_em: a list of all Professors

    INSTANCE ATTRIBUTES (those of Cornellian as well as):
        department [nonempty string]: the department of this professor
        advisees [possibly empty list of Student objects]: the Students that
            this professor is an advisor for
    """

    # STUDENTS--Put any class attributes here:



    def __init__():
        """ Initializes a Professor with first_name 'f' and last_name 'l'.

        The cuid of this Professor is a string with 3 characters: the lower-cased first
        letter of the Professor's first name and the lower-cased first letter of their
        last and then the value of NEXT_NUM.
        It also increments the Cornellian class attribute NEXT_NUM by one.

        Also, sets this Professor's departmnet to 'd' and advisees to the empty
        list (because when a professor first joins Cornell, they aren't assigned
        advisees right away!).

        If this professor's department is not already in Professor.departments,
            this method adds it so the list accurtately represents at
            departments at Cornell.

        Precondition:
            f is a nonempty string
            l is a nonempty string
            d is a (nonempty) string
        """

        # STUDENTS--You need to do the following:
            # 1. Put the parameters into the __init__ method header above
            # 2. Complete this method so it follows the specification above
        pass


class Student(Cornellian):
    """
    A class representing a student at Cornell.

    INSTANCE ATTRIBUTES (those of Cornellian as well as):
        college [possibly empty string]: the college of this student, empty
            string if unknown
        major [possibly empty string]: the major of this student
            Note: a student may only have one major and once it is declared,
            it may not change
        advisor [Professor or None]: the faculty adivsor of this student; department
            of this Professor should match this Student's major or be None.
    """


    # STUDNTS--Put any class attributes here (if there are any)


    def __init__():
        """ Initializes a Student with first_name 'f' and last_name 'l'.

        The cuid of this Students is a string with 3 characters: the lower-cased first
        letter of the Student's first name and the lower-cased first letter of their
        last and then the value of NEXT_NUM.
        It also increments the Cornellian class attribute NEXT_NUM by one.

        Also, sets this Student's minor to 'minor'.

        Precondition:
            f is a nonempty string
            l is a nonempty string
            college is a (possibly empty) string
                if a college is not given, it is set to the empty string
        """

        # STUDENTS--You need to do the following:
            # 1. Put the parameters into the __init__ method header above
                # (remember to make attributes optional if the spec says)
            # 2. Complete this method so it follows the specification above
        pass

    def chooseMajor():
        """ Updates this Students major to be 'major.'

        Once they pick a major, an advisor is assigned to them. The fauculty
        advisor's department should match the student's major. If there
        is not a professor in the department that matches the Student's major
        (meaning their department is not represent in Professor.departments),
        the Student's advisor is None. If there is more than one professor
        in this department, pick the first professor as they appear in
        Professor.all_of_em.

        Also puts this Student in their advisor's list of advisees if
        the Professor is not None.

        Preconditions:
            major is a string
        """

        # STUDENTS--You need to do the following:
            # 1. Put the parameters into the chooseMajor method header above
                # (remember to make attributes optional if the spec says)
            # 2. Complete this method so it follows the specification above
        pass
